package Magic;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import javax.swing.plaf.synth.*;
import javax.swing.plaf.ComponentUI.*;
import java.util.*;
import javax.naming.directory.*;
import java.awt.BorderLayout;
import java.awt.Font;
import java.io.*;
import java.net.URL;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;import java.nio.charset.Charset;


// Classe de fentre Swing permettant de visualiser un
// document (HTML ou texte)
public class DocumentViewer extends JPanel
                        implements HyperlinkListener,
                                       ActionListener
{
  // Composant Swing permettant de visualiser un document
  JEditorPane viewer       = new JEditorPane ();
  // Champ de saisie de l'URL  visualiser
  JTextField  urlTextField = new JTextField ();
	JComboBox sources;
	JComboBox docs;
private String[] tabType={"source","doc","home"};
private String [] tabFile={"MagicSquare","LatinSquare","HeteroSquare",
"OrthogonalSquare","MagicSequence"};
private String [] tabName={"Carr Magique","Carr Latin",
"Carr Htrogne","Carr Orthogonal","Sequence Magique"};
private int choice=0;

  public DocumentViewer ()
  {
	  setSize(550,420);
	  sources=new JComboBox(tabName);
docs=new JComboBox(tabType);
JLabel lab1=new JLabel("Fichier(s):");
	  JPanel paneURL=new JPanel();
    // Construction de l'Interface Graphique
    // Panel en haut avec un label et le champ de saisie
    JPanel inputPanel = new JPanel ();
    inputPanel.setLayout(new BorderLayout());
    JLabel label = new JLabel ("URL : ");
    Box box=Box.createHorizontalBox();
    box.add(Box.createHorizontalStrut(0));
    box.add (lab1);
    box.add(Box.createHorizontalStrut(0));
    box.add(sources);
    box.add(docs);
    inputPanel.add(box,BorderLayout.WEST);
    // Zone scrolle au centre avec le document
    JScrollPane scrollPane = new JScrollPane (viewer);
    // Ajout des composants  la fentre
   this.setLayout(new BorderLayout());
   this.add (inputPanel, BorderLayout.NORTH);
    this.add (scrollPane, BorderLayout.CENTER);

    // Mode non editable pour recevoir les clics sur les
    // liens hypertexte
    viewer.setEditable (false);
    // Ajout du listener de clic sur lien
    viewer.addHyperlinkListener (this);
    // Ajout du listener de modification de la saisie
    sources.addActionListener (this);
  docs.addActionListener(this);
    loadPage ("file:/"+replace(System.getProperty("user.dir"))+"/Magic/Note.html");

  }

  // Mthode appele aprs un clic sur un lien hyper texte
  public void hyperlinkUpdate (HyperlinkEvent event)
  {
    if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
    {
      // Modification du champ de saisie
      urlTextField.setText (event.getURL ().toString ());
      if (event instanceof HTMLFrameHyperlinkEvent)
      {
        // Evenement spcial en cas d'utilisation de Frame HTML
        HTMLDocument doc = (HTMLDocument)viewer.getDocument ();
        doc.processHTMLFrameHyperlinkEvent (
                       (HTMLFrameHyperlinkEvent)event);
      }
      else
        // Chargement de la page
        loadPage (urlTextField.getText ());
    }
  }
public String replace(String s1){
	String st="";
	char [] s=s1.toCharArray();
	for (int i=0;i<s.length;i++)
	if (s[i]=='\\')
	st+='/';
	else st+=s[i];
	return st;

	}
  // Mthode appele aprs une modification de la saisie
  public void actionPerformed (ActionEvent e)
  {//file =new File(System.getProperty("user.dir")+"/Magic/MagicProblems/"+tabFile[choixM.getSelectedIndex()]);
    Object o=e.getSource();

    if (o == sources)
    {if (choice==1)
    loadPage ("file:/"+replace(System.getProperty("user.dir"))+"/Magic/MagicProblems/"+tabFile[sources.getSelectedIndex()]+".java");
  else if (choice==2)
   loadPage ("file:/"+replace(System.getProperty("user.dir"))+"/docs/Magic/MagicProblems/"+tabFile[sources.getSelectedIndex()]+".html");


  }else if (o == docs)
  {		if (docs.getSelectedIndex()==0)
   {loadPage ("file:/"+replace(System.getProperty("user.dir"))+"/Magic/MagicProblems/"+tabFile[sources.getSelectedIndex()]+".java");
  choice=1;
  }

	  if (docs.getSelectedIndex()==2)
	  {loadPage ("file:/"+replace(System.getProperty("user.dir"))+"/Magic/note.html");
	  choice=3;
	  }else if (docs.getSelectedIndex()==1)
	  {
		  choice=2;
		  loadPage ("file:/"+replace(System.getProperty("user.dir"))+"/docs/Magic/MagicProblems/"+tabFile[sources.getSelectedIndex()]+".html");
}}
  }

  public void loadPage (String urlText)
  {
    try
    {
      // Modification du document visualise
      viewer.setPage (new URL (urlText));
    }
    catch (IOException ex)
    {
      System.err.println ("Acces impossible a " + urlText);
    }
  }

  // Mthode main () d'exemple de mise en oeuvre.
  // Utilisation : java DocumentViewer

}

